function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/* Copyright (c) 2015-present, salesforce.com, inc. All rights reserved */

/* Licensed under BSD 3-Clause - see LICENSE.txt or git.io/sfdc-license */
// ### React
import React from 'react';
import PropTypes from 'prop-types'; // ## Children

import Checkbox from '../../checkbox';
import HeaderCell from './header-cell'; // ## Constants

import { DATA_TABLE_HEAD } from '../../../utilities/constants';
/**
 * Used internally, provides header row rendering to the DataTable.
 */

var DataTableHead =
/*#__PURE__*/
function (_React$Component) {
  _inherits(DataTableHead, _React$Component);

  function DataTableHead() {
    _classCallCheck(this, DataTableHead);

    return _possibleConstructorReturn(this, (DataTableHead.__proto__ || Object.getPrototypeOf(DataTableHead)).apply(this, arguments));
  }

  _createClass(DataTableHead, [{
    key: "componentWillMount",
    // ### Display Name
    // Always use the canonical component name as the React display name.
    // ### Prop Types
    value: function componentWillMount() {} // ### Render

  }, {
    key: "render",
    value: function render() {
      var _this = this;

      return React.createElement("thead", null, React.createElement("tr", {
        className: "slds-line-height_reset"
      }, this.props.canSelectRows ? React.createElement("th", {
        className: "slds-text-align_right",
        scope: "col",
        style: {
          width: '3.25rem'
        }
      }, React.createElement("div", {
        className: "slds-th__action slds-th__action_form"
      }, React.createElement(Checkbox, {
        assistiveText: {
          label: this.props.assistiveText.selectAllRows
        },
        checked: this.props.allSelected,
        indeterminate: this.props.indeterminateSelected,
        id: "".concat(this.props.id, "-SelectAll"),
        name: "SelectAll",
        onChange: this.props.onToggleAll
      }))) : null, this.props.columns.map(function (column) {
        return React.createElement(HeaderCell, _extends({
          assistiveText: _this.props.assistiveText,
          id: "".concat(_this.props.id, "-").concat(column.props.property),
          key: "".concat(_this.props.id, "-").concat(column.props.property),
          onSort: _this.props.onSort
        }, column.props));
      }), this.props.showRowActions ? React.createElement("th", {
        scope: "col",
        style: {
          width: '3.25rem'
        }
      }, React.createElement("div", {
        className: "slds-th__action"
      }, React.createElement("span", {
        className: "slds-assistive-text"
      }, this.props.assistiveText.actionsHeader))) : null));
    }
  }]);

  return DataTableHead;
}(React.Component);

Object.defineProperty(DataTableHead, "displayName", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: DATA_TABLE_HEAD
});
Object.defineProperty(DataTableHead, "propTypes", {
  configurable: true,
  enumerable: true,
  writable: true,
  value: {
    assistiveText: PropTypes.shape({
      actionsHeader: PropTypes.string,
      columnSort: PropTypes.string,
      columnSortedAscending: PropTypes.string,
      columnSortedDescending: PropTypes.string,
      selectAllRows: PropTypes.string,
      selectRow: PropTypes.string
    }),
    allSelected: PropTypes.bool,
    indeterminateSelected: PropTypes.bool,
    canSelectRows: PropTypes.bool,
    columns: PropTypes.arrayOf(PropTypes.shape({
      Cell: PropTypes.func,
      props: PropTypes.object
    })),
    id: PropTypes.string,
    onToggleAll: PropTypes.func,
    onSort: PropTypes.func,
    showRowActions: PropTypes.bool
  }
});
export default DataTableHead;
//# sourceMappingURL=head.js.map